/* eslint-disable arrow-body-style */
const simApi = require('./sim.request-helper');
const delay = require('delay');

function getRandNum(min = 1, max = 100000) {
  return Math.floor(Math.random() * (max - min) + min);
}

// async function longPolling(count = 0, accessToken, since = null, loginId, matrixLoginId, deviceId) {
//   let syncResult;
//   let beforeTs = Date.now();
//   try {
//     syncResult = await simApi.sync(accessToken, since, false, 10000);
//     // console.log(syncResult);
//     const processTime = ((Date.now() - beforeTs) / 1000).toFixed();
//     if (processTime > 10) {
//       const logAt = new Date().toISOString();
//       console.log(`[${logAt}] Success to long polling - loginId:${loginId}, count: ${count}, processTime: ${processTime}secs`);
//     }
//   } catch (err) {
//     // console.log(err);
//     const processTime = ((Date.now() - beforeTs) / 1000).toFixed();
//     if (since) {
//       syncResult = { next_batch: since };
//     } else {
//       syncResult = { next_batch: null };
//     }
// 	  const logAt = new Date().toISOString();
// 	  console.log(`[${logAt}] Fail to long polling - loginId:${loginId}, count: ${count}, processTime: ${processTime}secs`);
//   }
//
//   if (count < 3600000) {
//     count++;
//     if (getRandNum() % 2 === 0) {
//       setTimeout(async () => {
//         const txnId = `m${Date.now()}.0`;
//         await simApi.sendToDevice(accessToken, matrixLoginId,
//           [deviceId], 'm.test', txnId, { a: 'test' });
//       }, getRandNum(1000, 9000))
//     }
//
//     await delay(getRandNum(1000, 5000));
//     await longPolling(count, accessToken, syncResult.next_batch, loginId, matrixLoginId, deviceId);
//   }
// }

async function longPolling_2(accessToken, loginId, matrixLoginId, deviceId) {
  let syncResult;
  let since = null;
  let count = 0;

  while(true) {
    let beforeTs = Date.now();
    try {
      syncResult = await simApi.sync(accessToken, since, false, 10000);
      // console.log(syncResult);
      const processTime = ((Date.now() - beforeTs) / 1000).toFixed();
      if (processTime > 10) {
        const logAt = new Date().toISOString();
        console.log(`[${logAt}] Success to long polling - loginId:${loginId}, count: ${count}, processTime: ${processTime}secs`);
      }
      since = syncResult.since;
    } catch (err) {
      const processTime = ((Date.now() - beforeTs) / 1000).toFixed();
      const logAt = new Date().toISOString();
      console.log(`[${logAt}] Fail to long polling - loginId:${loginId}, count: ${count}, processTime: ${processTime}secs`);
    }

    count++;
    if (getRandNum() % 2 === 0) {
      setTimeout(async () => {
        const txnId = `m${Date.now()}.0`;
        await simApi.sendToDevice(accessToken, matrixLoginId,
          [deviceId], 'm.test', txnId, { a: 'test' });
      }, getRandNum(1000, 9000))
    }

    await delay(getRandNum(1000, 5000));
  }
}

(async () => {
  try {
    console.log('started************');

    // Get Users
    const userList = [];
    let result;
    const userPw = '12341234';

    for (let idx = 0; idx < 500 ; idx += 1) {
      const userId = `test_${idx}`;
      try {
        result = await simApi.register(userId, userPw);
      } catch (err) {
        if (err.response.data.errcode === 'M_USER_IN_USE') {
          result = await simApi.loginWithPassword(userId, userPw);
        }
      }
      const { user_id, access_token, device_id } = result;
      userList.push({
          regAccessToken: access_token,
          loginId: user_id,
          matrixLoginId: user_id,
          device_id: device_id,
        });
    }

    // userList
    const longPollingResults = await Promise.all(userList.map(async ({ regAccessToken, loginId, matrixLoginId, regDeviceId }) => {
      try {
        // await longPolling(0, regAccessToken, null, loginId, matrixLoginId, regDeviceId);
        await longPolling_2(regAccessToken, loginId, matrixLoginId, regDeviceId);
         console.log(`Finish to long polling - loginId:${loginId}`);
        return true;
      } catch (err) {
        return false;
      }
    }));

    let successCount = 0;
    let failCount = 0;
    longPollingResults.forEach((v) => {
      if (v) {
        successCount ++;
      } else {
        failCount++;
      }
    });

    console.log(`Finish to all long polling - success count: ${successCount} - fail count: ${failCount}`)
    console.log('ended ************');
  } catch (err) {
    console.log(err);
    if (err.response) {
      console.log(err.response.data);
    }
  }
})();